define(['underscore', 'car', 'bike'], function (_, car, bike) {
    var shop = function (myBank) {
        var that = {}, stock = [], itemId = -1;

        that.getItemsOfType = function (itemType) {
            return _.filter(stock, function (item) {
                return item.getItemType() === itemType;
            });
        };

        that.buyItem = function (item) {
            if (myBank.withdraw(item.getPurchasePrice())) {
                item.setId(++itemId);
                stock.push(item);
                console.log('Item added to the stock (id:', item.getId() + ')');
                return item.getId();
            }

            console.log('Not enough savings to buy this item');
            return null;
        };

        that.sellItem = function (id) {
            var item = _.find(stock, function (item) {
                return item.getId() === id;
            });

            if (item) {
                stock.splice(stock.indexOf(item), 1);
                myBank.deposit(item.getSellingPrice());
                console.log('Item with id ', id, ' sold');
                return id;
            }

            console.log('Item with id ', id, 'not in stock');
            return null;
        };

        return that;
    };
    return shop;
});